struct ff_envelope
Prev | Chapter 25. Input Subsystem | Next

## Name

struct ff_envelope — generic force-feedback effect envelope

## Synopsis

    struct ff_envelope {
      __u16 attack_length;
      __u16 attack_level;
      __u16 fade_length;
      __u16 fade_level;
    };

## Members

attack_length

  duration of the attack (ms)

attack_level

  level at the beginning of the attack

fade_length

  duration of fade (ms)

fade_level

  level at the end of fade

## Description

The `attack_level` and `fade_level` are absolute values; when applying envelope force-feedback core will convert to positive/negative value based on polarity of the default level of the effect. Valid range for the attack and fade levels is 0x0000 - 0x7fff

Prev | Up | Next
struct ff_trigger | Home | struct ff_constant_effect